stages:
  - build
  - upload
  - release

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  TAG_RUNNER: vc15
  PTHREAD_VER: "2.9.1"
  PREFIX_NAME: "pthreads-win32-${PTHREAD_VER}"
  DIST_NAME_x86: "${PREFIX_NAME}_x86_${VC_VER}.zip"
  DIST_NAME_x64: "${PREFIX_NAME}_x64_${VC_VER}.zip"
  PACKAGE_REGISTRY_ID: "35357105"
  PACKAGE_REGISTRY_URL: "${CI_API_V4_URL}/projects/${PACKAGE_REGISTRY_ID}/packages/generic/pthreads-win32/${PTHREAD_VER}"
  VCVARS_VER: "14.16.27023"
  VC_VER: "v141"

build-x86:
  stage: build
  tags:
    - $TAG_RUNNER
  script:
    - $env:VERS = ${PTHREAD_VER} -replace "\.","-"
    - $env:ARCH = "x86"
    - $env:DIST_NAME = "${DIST_NAME_x86}"
    - cmd /c 'build.bat'
  artifacts:
    paths:
      - deploy

build-x64:
  stage: build
  tags:
    - $TAG_RUNNER
  script:
    - $env:VERS = ${PTHREAD_VER} -replace "\.","-"
    - $env:ARCH = "x64"
    - $env:DIST_NAME = "${DIST_NAME_x64}"
    - cmd /c 'build.bat'
  artifacts:
    paths:
      - deploy

upload:
  stage: upload
  rules:
    - if: $CI_COMMIT_TAG
  tags:
    - $TAG_RUNNER
  script:
    - |
      $files = Get-ChildItem ".\deploy"
      $json = "["
      foreach ($f in $files){
          $fn = Split-Path $f -leaf
          $uri = ${PACKAGE_REGISTRY_URL} + "/" + ${fn}
          $json += "{`"name`":`"${fn}`",`"url`":`"${uri}`"},"
          Invoke-RestMethod -Headers @{ "JOB-TOKEN"="$CI_JOB_TOKEN" } -InFile ${f} -uri "${uri}" -Method put
      }
      $json = $json -replace ".$"
      $json += "]"
      "$json" | out-file -filepath .\dump.json
  artifacts:
    paths:
      - dump.json

release:
  stage: release
  rules:
    - if: $CI_COMMIT_TAG
  tags:
    - $TAG_RUNNER
  dependencies:
    - upload
  script:
    - |
      $j = Get-Item -Path .\dump.json | Get-Content -Tail 1 | ConvertTo-Json
      release-cli --additional-ca-cert-bundle .\gitlab.com.crt create --name $CI_COMMIT_TAG --description "Release $CI_COMMIT_TAG" --ref $CI_COMMIT_TAG --tag-name $CI_COMMIT_TAG --assets-link=$j
